package com.huifu.adapay.widgets;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.huifu.adapay.R;
import com.huifu.adapay.beans.PayTypeBean;

import java.util.List;


public class PayTypeListAdapter extends BaseAdapter {

    private Context context;
    private List<PayTypeBean> dataList;

    public PayTypeListAdapter(Context context, List<PayTypeBean> dataList) {
        this.context = context;
        this.dataList = dataList;
    }

    @Override
    public int getCount() {
        return dataList.size();
    }

    @Override
    public Object getItem(int i) {
        return null;
    }

    @Override
    public long getItemId(int i) {
        return 0;
    }

    @Override
    public View getView(int i, View view, ViewGroup viewGroup) {
        Holder holder;
        if (view == null) {
            holder = new Holder();
            view = LayoutInflater.from(context).inflate(R.layout.layout_pay_type_item, null);
            holder.tvPayType = view.findViewById(R.id.tv_pay_type);
            holder.ivPayIcon = view.findViewById(R.id.iv_pay_icon);
            holder.ivCheckBox = view.findViewById(R.id.iv_check_icon);

            view.setTag(holder);
        } else {
            holder = (Holder) view.getTag();
        }

        holder.tvPayType.setText(dataList.get(i).getPayTypeName());
        holder.ivPayIcon.setImageResource(dataList.get(i).getPayIcon());
        holder.ivCheckBox.setVisibility(dataList.get(i).isChecked() ? View.VISIBLE : View.GONE);

        return view;
    }

    private class Holder {
        private TextView tvPayType;
        private ImageView ivPayIcon;
        private ImageView ivCheckBox;
    }
}
