package com.huifu.adapay.wxapi;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;

import com.alibaba.fastjson.JSON;
import com.chinapnr.android.adapay.bean.ResponseCode;
import com.huifu.adapay.beans.respbean.WXLiteResultBean;
import com.huifu.adapay.Config;
import com.huifu.adapay.PayResultActivity;
import com.huifu.adapay.R;
import com.tencent.mm.opensdk.constants.ConstantsAPI;
import com.tencent.mm.opensdk.modelbase.BaseReq;
import com.tencent.mm.opensdk.modelbase.BaseResp;
import com.tencent.mm.opensdk.modelbiz.WXLaunchMiniProgram;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.IWXAPIEventHandler;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;

/**
 * 微信 sdk 专用回调
 */
public class WXEntryActivity extends Activity implements IWXAPIEventHandler {

    private IWXAPI api;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_wxentry);

        api = WXAPIFactory.createWXAPI(this, Config.WECHAT_APPID);
        api.registerApp(Config.WECHAT_APPID);

        api.handleIntent(getIntent(), this);
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        api.handleIntent(getIntent(), this);
    }

    // 微信发送请求到第三方应用时，会回调到该方法
    @Override
    public void onReq(BaseReq baseReq) {
    }

    // 第三方应用发送到微信的请求处理后的响应结果，会回调到该方法
    @Override
    public void onResp(BaseResp baseResp) {
        if (baseResp.getType() == ConstantsAPI.COMMAND_LAUNCH_WX_MINIPROGRAM) {
            //小程序回调
            WXLaunchMiniProgram.Resp launchMiniProResp = (WXLaunchMiniProgram.Resp) baseResp;
            String extraData = launchMiniProResp.extMsg;
            WXLiteResultBean resultBean = JSON.parseObject(extraData, WXLiteResultBean.class);

            startToResultAvtivity(resultBean);
        }
    }

    private void startToResultAvtivity(WXLiteResultBean resultBean) {

        final String SUCCEED = "succeeded";

        Intent intent = new Intent(this, PayResultActivity.class);
        intent.putExtra(PayResultActivity.PAYMENT_INFO, resultBean.getResult_info());

        String resultCode;
        if (SUCCEED.equals(resultBean.getResult_status())) {
            resultCode = ResponseCode.SUCCESS;
        } else {
            resultCode = ResponseCode.FAILED;
        }

        intent.putExtra(PayResultActivity.TRADE_CODE, resultCode);
        intent.putExtra(PayResultActivity.TRADE_MSG, resultBean.getResult_message());
        startActivity(intent);
        finish();
    }
}
